<!DOCTYPE html><html lang="en"><head>
<title>Client Certificate Demo</title>
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8">
<meta name="viewport" content="width=device-width, initial-scale=1.0">
<style>
    body {
        font-family: Tahoma, Verdana, Arial, sans-serif;
    }
    BODY {
        margin: 2em;
    }
</style>
</head>
<body>
<h1>Client Certificate Demo</h1>

<p>User/email: <input type="text" />
<br />
Password: <input type="password" />
<br />
<input type="submit" />
</p>

<p><a href="https://sx509.w0.dk/">https://<b>s</b>x509.w0.dk/</a> Click here to logon with Client Certificate (use Mozilla Firefox)</p>

<br />
<hr>

<h1>Video demonstration</h1>
<iframe width="640" height="360" src="//www.youtube.com/embed/KWtmljvuYJ4?feature=player_embedded" frameborder="0" allowfullscreen></iframe>
<hr>

<h2>Get your own client certificate</h2>
<h3>Create a client certificate on cacert.org</h3>
<p>Without installing software you can go to
<a href="https://www.cacert.org/index.php?id=1">cacert.org</a> and create one.</p>

<h3>Create a '*.p12' file with OpenSSL</h3>
<pre>
NAME="John Doe"
EMAIL="john.doe@example.org"
FILE=${EMAIL/@/_}
openssl req -x509 -sha256 -nodes -subj "/C=DK/ST=Interstate/L=Capital/O=Acme/OU=IT/CN=$NAME/emailAddress=$EMAIL" -days 7300 -newkey rsa:2048 -keyout $FILE.key -out $FILE.pem
openssl pkcs12 -export -in $FILE.pem -inkey $FILE.key -out $FILE.p12
</pre>

<p>If you can not generate this PKCS12 file yourself, then grab a test one here:
<a href="john.doe_example.org.p12">john.doe_example.org.p12</a> - it has no password.</p>

<h2>Import the P12 client certificate into your browser</h3>

<p>It is done differently for all browseres. Smartphones are worse.</p>

<h3>Firefox</h3>

<ol>
<li>Click the <i>burger</i>-menu in upper right corner</li>
<li>Click Preferences</li>
<li>Click Privacy &amp; Security <a href="about:preferences#privacy">about:preferences#privacy</a></li>
<li>Scroll down to the bottom</li>
<li>Click button [View <u>C</u>ertificates...]</li>
<li>Click button [I<u>m</u>port...]</li>
</ol>
<img src="import-firefox.png" alt="import-firefox.png">

<h3>Chrome</h3>

<p>Open your settings in Google Chrome: <a href="chrome://settings/certificates">chrome://settings/certificates</a>
and import the <b>*.p12</b> file.
Chrome says the certificate is untrusted, but you trust it as you generated it.</p>

<p>Now you can visit: <a href="https://sx509.w0.dk/">https://<b>s</b>x509.w0.dk/</a></p>

<h3>curl</h3>

<p>A quick test can be done by using <tt>curl</tt> together with the P12-file:</p>

<pre>
$ curl -s --cert-type P12 --cert <b>john.doe_example.org.p12</b> https://sx509.w0.dk/ | grep SSL_
&lt;p&gt;Source: &lt;tt&gt;Welcome: &amp;lt;&lt;?php if (preg_match("/=([A-Z0-9._%+-]+@[A-Z0-9.-]+\.[A-Z]{2,})/i", $_SERVER["SSL_CLIENT_S_DN"], $m)) echo $m[1] ?&gt;&amp;gt; '&lt;?= $_SERVER["SSL_CLIENT_SERIAL"] ?&gt;'&lt;/tt&gt;&lt;/p&gt;
&lt;caption&gt;Environment variables which match &lt;tt&gt;SSL_*&lt;/tt&gt;&lt;/caption&gt;
&lt;tr&gt;&lt;td&gt;SSL_SERVER_NAME&lt;/td&gt;&lt;td&gt;x509.w0.dk&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_PROTOCOL&lt;/td&gt;&lt;td&gt;TLSv1.2&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_CLIENT_VERIFY&lt;/td&gt;&lt;td&gt;FAILED&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_CLIENT_SERIAL&lt;/td&gt;&lt;td&gt;9542F240CF4B0BC4&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_CLIENT_S_DN&lt;/td&gt;&lt;td&gt;/C=DK/ST=Interstate/L=Capital/O=Acme/OU=IT/CN=John Doe/emailAddress=john.doe@example.org&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_CLIENT_I_DN&lt;/td&gt;&lt;td&gt;/C=DK/ST=Interstate/L=Capital/O=Acme/OU=IT/CN=John Doe/emailAddress=john.doe@example.org&lt;/td&gt;&lt;/tr&gt;
&lt;tr&gt;&lt;td&gt;SSL_CLIENT_FINGERPRINT&lt;/td&gt;&lt;td&gt;08f7d7359d1d0fdeee9c1e3ac799314dad48267c&lt;/td&gt;&lt;/tr&gt;
$_SERVER['SSL_CLIENT_I_DN'] = /C=DK/ST=Interstate/L=Capital/O=Acme/OU=IT/CN=John Doe/emailAddress=john.doe@example.org
$_SERVER['SSL_CLIENT_SERIAL'] = <b>9542F240CF4B0BC4</b>
$_SERVER['SSL_CLIENT_S_DN'] = /C=DK/ST=Interstate/L=Capital/O=Acme/OU=IT/CN=John Doe/emailAddress=john.doe@example.org
$_SERVER['SSL_CLIENT_S_DN_CN'] = 
$_SERVER['SSL_CLIENT_S_DN_G'] = 
$_SERVER['SSL_CLIENT_S_DN_S'] = 
$_SERVER['SSL_CLIENT_VERIFY'] = FAILED
</pre>

<hr>

<h2>Documentation</h2>

<p>A good page to start: <a href="http://cweiske.de/tagebuch/ssl-client-certificates.htm">Using SSL Client Certificates with PHP</a>.</p>

<p>When nginx has been configured it can be verified with <tt>curl</tt>:
<pre>
$ curl -v -o /dev/null https://x509.w0.dk/ 2|&amp; grep Req
* TLSv1.2 (IN), TLS handshake, Request CERT (13):
</pre>

<h3>The Nginx conf:</h3>
<pre>
log_format sslclient
    '"$ssl_client_s_dn" $ssl_client_serial $ssl_client_fingerprint'
    ' $remote_addr - $remote_user [$time_iso8601]'
    ' "$request" $status $body_bytes_sent $request_time'
    ' "$http_referer" "$http_user_agent"';

server {
    listen 443 ssl;
    listen [::]:443 ssl; # only for IPv6
    server_name sx509.w0.dk;
    root /var/www/sx509.w0.dk;
    access_log /var/log/nginx/sx509.w0.dk/access.log sslclient;
    error_log /var/log/nginx/sx509.w0.dk/error.log;
    index index.php index.html;

    ssl_certificate /root/.acme.sh/sx509.w0.dk/fullchain.cer;
    ssl_certificate_key /root/.acme.sh/sx509.w0.dk/sx509.w0.dk.key;
 
    # Entries required for client side certificate
    ssl_verify_client optional_no_ca;
    ssl_verify_depth 1;


    location ~ \.php$ {
        fastcgi_param SSL_CIPHER $ssl_cipher;
        fastcgi_param SSL_CIPHERS $ssl_ciphers;
        fastcgi_param SSL_CLIENT_CERT $ssl_client_cert;
        fastcgi_param SSL_CLIENT_ESCAPED_CERT $ssl_client_escaped_cert;
        fastcgi_param SSL_CLIENT_FINGERPRINT $ssl_client_fingerprint;
        fastcgi_param SSL_CLIENT_I_DN $ssl_client_i_dn;
        fastcgi_param SSL_CLIENT_I_DN_LEGACY $ssl_client_i_dn_legacy;
        fastcgi_param SSL_CLIENT_RAW_CERT $ssl_client_raw_cert;
        fastcgi_param SSL_CLIENT_S_DN $ssl_client_s_dn;
        fastcgi_param SSL_CLIENT_S_DN_LEGACY $ssl_client_s_dn_legacy;
        fastcgi_param SSL_CLIENT_SERIAL $ssl_client_serial;
        fastcgi_param SSL_CLIENT_V_END $ssl_client_v_end;
        fastcgi_param SSL_CLIENT_VERIFY $ssl_client_verify;
        fastcgi_param SSL_CLIENT_V_REMAIN $ssl_client_v_remain;
        fastcgi_param SSL_CLIENT_V_START $ssl_client_v_start;
        fastcgi_param SSL_CURVES $ssl_curves;
        fastcgi_param SSL_PROTOCOL $ssl_protocol;
        fastcgi_param SSL_SERVER_NAME $ssl_server_name;
        fastcgi_param SSL_SESSION_ID $ssl_session_id;
        fastcgi_param SSL_SESSION_REUSED $ssl_session_reused;

        include snippets/fastcgi-php.conf;
        fastcgi_pass unix:/run/php/php7.3-fpm.sock;
    }

    location / {
    }
}
</pre>

<h3>Download</h3>

<p><a href="client-certificate.x509.demo-files.2020-12-20.tar.gz">client-certificate.x509.demo-files.2020-12-20.tar.gz</a></p>
<pre>
etc/nginx/sites-available/x509.w0.dk.conf
etc/nginx/sites-available/sx509.w0.dk.conf
var/www/x509.w0.dk/
var/www/x509.w0.dk/import-firefox.png
var/www/x509.w0.dk/index.php
var/www/x509.w0.dk/john.doe_example.org.p12
var/www/sx509.w0.dk/
var/www/sx509.w0.dk/index.php
</pre>
	</body>
</html>
